#ifndef INOUT_H
#define INOUT_H

#include "../Common/readnums.h"           /* readVector()    */
#include "tools.h"
#include "structs.h"

#include <dirent.h>             /* readdir(), etc. */
#include <getopt.h>
#include <sys/dir.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/stat.h>           /* stat(), etc.    */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

extern int alphasort();

void getPath(char *pathname);
phoneme** readDatasetFile(char *filename, int *count);
phoneme* readFile(char *filename, int dim);
phoneme** readAllFiles(char *pathname, int *ph_sum, int *maxPathSize);
int file_select(struct direct *entry);
int decideDimensions(char *filename);

void printPath(char *array);
void printFrame(double *fp, int w);
void printFrames(phoneme *p);
void printPhoneme(phoneme *p);
void printPhonemes(phoneme **phs, int n);
void printPrototypes(phoneme **protos, int k);
void printClusters(cluster **cs, int m);
void printClusterSizes(cluster **cs, int m);
void printMatrix(double **M, int side);
void printDTWMatrix(double **M, int rows, int columns);
void printClusterStatus(cluster **cs, int m);
void printClusterStatusSimple(cluster **cs, int m);
void printUsage();
void printParams();
void printResults(double dist, phoneme **phs, phoneme **class, int n, int r, int k);
void printResultsNoLC(double dist, phoneme **phs, phoneme **class, int n);

parameters* initParams();
void freeParams(parameters *param);
void processParams(parameters *param, int argc, char **argv);

#endif /* inout.h */
