#ifndef MEASURES_H
#define MEASURES_H

#include "structs.h"
#include "tools.h"
#include <math.h>

#define DBL_MAX 1.0e35
#define DBL_EPSILON 1.0e-5
#define FALSE 0
#define TRUE !FALSE
#define MAXEXTENSIONLEN 5

double getEuclideanDistance(double *a, double *b, int *dim);
double getSquareDistance(double *a, double *b, int *dim);
double point2LineSegmentDistance2D(double *p, double *line1, double *line2, int *dim);
double DTW(phoneme *ph1, phoneme *ph2);
phoneme **initialPointReduction(phoneme **phs, int n, double tolerance);
double DTWpath(phoneme *ph1, phoneme *ph2, double *curr_best);
double closestDist(phoneme *ph1, phoneme *ph2);
double minPrev(double *M, int end);
double optimalSegmentationDistance(phoneme *ph1, phoneme *ph2);
double DTWpath2mat(phoneme *ph1, phoneme *ph2, char *m_cell);
void backtrackPath(phoneme *ph, double **DTW_M, int n, int m);
void backtrackPath2mat(char *cell, double **DTW_M, int n, int m);
double** getDistanceMatrix(phoneme **phs, unsigned int n);
double** getDistanceMatrixWithPath(phoneme **phs, unsigned int n, char ***p);
double* getDistanceVector(phoneme **phs, unsigned int n, int *idx);
double* getDistanceVectorWithPath(phoneme **phs, unsigned int n, int *idx, char **paths, int plen);
void calculateIntDist(cluster *c, double value);
void calculateInternalDistortion(cluster *c);
double calculateExternalDistortion(int n, cluster **cs, int m);
double calculateDistortion(int n, cluster **C, int m);
double ClassificationError(phoneme **phs, phoneme **ts, int n);

#endif /* MEASURES_H */
