#ifndef STRUCTS_H
#define STRUCTS_H

#include <sys/param.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define DBL_MAX 1.0e35
#define DBL_EPSILON 1.0e-5
#define FALSE 0
#define TRUE !FALSE
#define TOLERANCE 0.01
#define MAXEXTENSIONLEN 5

typedef struct c cluster;
typedef struct p phoneme;
typedef struct param parameters;
typedef struct direct directory;

struct param {
  char *path;
  char *indir;
  char *outdir;
  char *extension;
  int clusters;
  int cmethod;
  int iterations;
  int kmIters;
  int oneFile;
};

struct c
{
  int cNo;
  int phAmount;
  double distortion;
  phoneme *exemplar;
  phoneme **phs;
};

struct p
{
  int phNo;
  int dimensions;
  int frameAmount;
  int myCluster;
  double distortion;
  char *DTWpath;
  char *filename;
  double **frames;
};

phoneme* newPhoneme(char *name, int dim);
phoneme** newPhonemes(int count);
void allocateDTWpaths(phoneme **phs, int n, int maxPathLen);
cluster* newCluster(int maxph, int cnumber);
cluster** newClusters(int n, int m);
double* newFrame(int dim);
double** newFrames(int frAmount, int dim);
char*** newPathMatrix(int n, int l);
char** newPathVector(int n, int l);
phoneme** newPrototypes(cluster **cs, int k);
void insertFrame(phoneme *p, double *values);
void freeClusters(cluster **cs, int m);
void freePhoneme(phoneme *ph);
void freePhonemes(phoneme **phs, int n);
void freePathMatrix(char ***p, int n, int l);
void freePrototypes(phoneme **protos, int k);

#endif /* STRUCTS_H */


