#ifndef TOOLS_H
#define TOOLS_H

#include "structs.h"
#include "tsc.h"

#define ABS(x)       ((x) < 0 ? -(x) : (x))
#define MINOF(x,y,z) MIN(MIN(x,y),z)
#define MAXOF(x,y,z) MAX(MAX(x,y),z)

char* iToStr(int number);
double RelDif(double a, double b);
int countLines(char *filename);
int checkIfDone(cluster **cs, phoneme **ex, int *sizes, int size);
int checkIfDoneSizes(cluster **cs, int *sizes, int size);
int biggestOf(double *T, int k);
int smallestOf(double *T, int k);
int inList(int *list, int size, int value);
int isExemplar(phoneme *ph, cluster **cs, int m);
int countMaxFrameSize(phoneme **phs, int n);

void addFrameValues(double *proframe, double *frame, int dim);
void clearPrototype(double **frames, int n, int m);
double** reallocateFrames(phoneme *target, int newRows, int newColumns);
void formMeanPhoneme(phoneme *proto, cluster *cs);
void invertDTWpath(char *array);
void copyPaths(char *a, char *b);
void copyAndFlipPaths(char *a, char *b);
void copyCluster(cluster *target, cluster *source);
void copyClusters(cluster **target, cluster **source, int m);
void copyPhAndCluster(cluster *target, cluster *source);
void copyPhsAndClusters(cluster **target, cluster **source, int m);
void copyPrototype(phoneme *target, phoneme *source);
void copyPrototypes(phoneme **targets, phoneme **sources, int n);
void resetCluster(cluster *cs);
void resetClusters(cluster **cs, int m);
void resetPhsAndCluster(cluster *cs);
void resetPhsAndClusters(cluster **cs, int m);
void resetPrototype(phoneme *proto);
void resetPrototypes(phoneme **protos, int n);

void getRandomCodebook(phoneme **phs, cluster **cs, int n, int m);
void createClassification(phoneme **phs, int n);

#endif
