#ifndef TSC_H
#define TSC_H

#include "measures.h"
#include "inout.h"
#include "structs.h"
#include "tools.h"

#include <math.h>               /* sqrt(), etc.    */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

void assignClusters(phoneme **phs, cluster **cs, int n, int m);
void assignMedoid(cluster *cs);
void assignMedoids(cluster **cs, int m);
void assignMedoid_Prototype(cluster *cs, int plen);
void assignMedoids_Prototype(cluster **cs, int m, int pathlen);
void assignDTWpaths(phoneme **phs, cluster **cs, int n);
void assignPathsForCluster(phoneme **phs, phoneme *proto, int n);
void updatePrototype(phoneme *proto, cluster *cs);
void updatePrototypes(phoneme **protos, cluster **cs, int m);
double kMedoids(phoneme **phs, cluster **cs, int n, int k, int *iters);
double iter_kMedoids(phoneme **phs, cluster **cs, int n, int m, int iterations, int *kmIters);
double kMedoids_Prototype(phoneme **phs, cluster **cs, phoneme **prototypes, int n, int k, int plen, int *iters);
double kMedoids_Proposed(phoneme **phs, cluster **cs, phoneme **prototypes, int n, int k, int plen, int *iters);
void swapCluster(phoneme **phs, cluster **cs, int n, int m, int *from, int *to);
void swapPrototype(phoneme **phs, cluster **cs, phoneme **protos, int n, int m, int *from, int *to);
double RLS(phoneme **phs, cluster **cs, int n, int m, int r, int *iters);
double RLS_Prototype(phoneme **phs, cluster **cs, phoneme **protos, int n, int m, int r, int plen, int *iters);
double RLS_Proposed(phoneme **phs, cluster **cs, phoneme **protos, int n, int m, int r, int plen, int *iters);
double RLS_Class(phoneme **phs, cluster **cs, phoneme **class, int n, int m, int r, int *iters);
double RLS_Prototype_Class(phoneme **phs, cluster **cs, phoneme **protos, phoneme **class, int n, int m, int r, int plen, int *iters);
double RLS_Proposed_Class(phoneme **phs, cluster **cs, phoneme **protos, phoneme **class, int n, int m, int r, int plen, int *iters);
double avgClusterDistance(cluster *cs1, cluster *cs2);
void initHC(phoneme **phs, cluster **cs, int n, int target_c);
double** calculateAvgClusterDistances(cluster **cs, int n);
double HC(phoneme **phs, cluster **cs, int n, int target_c);
double HC_Prototype(phoneme **phs, cluster **cs, phoneme **protos, int n, int target_c, int plen);
double HC_Proposed(phoneme **phs, cluster **cs, phoneme **protos, int n, int target_c, int plen);

#endif  /* TSC_H */
